Subject: Re: write hangs on socket shut down for writing
From: Yitzchak Scott-Thoennes <[email-masked]>
To: [email-masked]
Date: Fri, 21 May 2004 09:03:57 -0700

On Wed, Apr 21, 2004 at 11:50:59AM +0200, Corinna Vinschen <[email-masked]> wrote:
> On Apr 21 02:36, Yitzchak Scott-Thoennes wrote:
> > On Wed, Apr 21, 2004 at 10:46:59AM +0200, Corinna Vinschen <[email-masked]> wrote:
> > > Did you try it with a recent Cygwin version?  I used your above test
> > > application and I'm getting a EPIPE (resp. a SIGPIPE) as expected.
> > 
> > I think I had heard that others were not seeing this failure.  I'm
> > attaching an strace from my test program in case that may be helpful.
> > Is there anything you can think of that might make a difference?
> 
> Would you mind to debug that by yourself?  You are seeing this problem so
> I guess you're the best person to debug that problem.  Setting a breakpoint
> to 'fhandler_socket::sendmsg(msghdr const*, int, int)' should be fine.
> I can't see any reason for Cygwin to do that.  There's no loop anywhere
> which could run endlessly.  So either WSASendTo itself hangs, which is
> pretty unlikely for overlapped sockets, or WSASendTo returns SOCKET_ERROR
> and WSAGetLastError returns WSA_IO_PENDING so that WSAWaitForMultipleEvents
> in wsock_event::wait hangs.  Any chance that a firewall or anti-virus
> software is interfering?

I never had a chance to debug this, but upgrading to the 20040520
snapshot (from the 20040430) fixed this (as well as a hang using perl
Net::Ping to ping 127.0.0.1 via udp that I was seeing and others
apparently weren't.)

Both were probably dependent on firewall (McAfee) or vpn software
(Check Point VPN-1 SecureClient NG) I'm running, but seem to be better
now.

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/